Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Parkinson.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Parkinson.cs	(revision 8903)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Parkinson.cs	(revision 8903)
@@ -0,0 +1,45 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Parkinson : IUCIDataDescriptor {
+    public string Name { get { return "Parkinson"; } }
+    public string Description {
+      get {
+        return "Data Set Information:" + Environment.NewLine
+        + "This dataset is composed of a range of biomedical voice measurements from 31 people, 23 with "
+        + "Parkinson's disease (PD). Each column in the table is a particular voice measure, and each row "
+        + "corresponds one of 195 voice recording from these individuals (\"name\" column). The main aim of "
+        + "the data is to discriminate healthy people from those with PD, according to \"status\" column which "
+        + "is set to 0 for healthy and 1 for PD." + Environment.NewLine
+        + "Further details are contained in the following reference -- if you use this dataset, please cite: " + Environment.NewLine
+        + "Max A. Little, Patrick E. McSharry, Eric J. Hunter, Lorraine O. Ramig (2008), 'Suitability of "
+        + "dysphonia measurements for telemonitoring of Parkinson's disease', IEEE Transactions on Biomedical "
+        + "Engineering (to appear)." + Environment.NewLine
+        + "Note: The column \"name\" has been removed and the column \"status\" has been moved to the end.";
+      }
+    }
+    public string Donor { get { return "Max Little"; } }
+    public int Year { get { return 2008; } }
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs	(revision 8900)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs	(revision 8903)
@@ -49,5 +49,7 @@
       descriptorList.Add(new Iris());
       descriptorList.Add(new Mammography());
+      descriptorList.Add(new Parkinson());
       descriptorList.Add(new Thyroid());
+      descriptorList.Add(new Vertebral_3C());
       descriptorList.Add(new Wine());
       var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
@@ -62,6 +64,6 @@
             string prettyName = Path.GetFileNameWithoutExtension(entry);
             IUCIDataDescriptor desc = descriptorList.Where(x => x.Name.Equals(prettyName)).FirstOrDefault();
-            prettyName = String.Format("{0}, {1}, {2}", prettyName, desc.Donor, desc.Year);
             if (desc != null) {
+              prettyName = String.Format("{0}, {1}, {2}", prettyName, desc.Donor, desc.Year);
               yield return new ResourceClassificationDataDescriptor(prettyName, desc.Description, entry);
             } else
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Vertebral_3C.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Vertebral_3C.cs	(revision 8903)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Vertebral_3C.cs	(revision 8903)
@@ -0,0 +1,45 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Vertebral_3C : IUCIDataDescriptor {
+    public string Name { get { return "Vertebral_3C"; } }
+    public string Description {
+      get {
+        return "Data Set Information:" + Environment.NewLine
+        + "Biomedical data set built by Dr. Henrique da Mota during a medical residence "
+        + "period in the Group of Applied Research in Orthopaedics (GARO) of the Centre "
+        + "Médico-Chirurgical de Réadaptation des Massues, Lyon, France. The data have been "
+        + "organized in two different but related classification tasks. The first task consists "
+        + "in classifying patients as belonging to one out of three categories: Normal (100 patients), "
+        + "Disk Hernia (60 patients) or Spondylolisthesis (150 patients)." + Environment.NewLine
+        + "Each patient is represented in the data set by six biomechanical attributes derived from "
+        + "the shape and orientation of the pelvis and lumbar spine (in this order): pelvic incidence, "
+        + "pelvic tilt, lumbar lordosis angle, sacral slope, pelvic radius and grade of spondylolisthesis." + Environment.NewLine
+        + "Note: Normal has the value '0', Spondylolisthesis is '1' and Disk Hernia = '2'.";
+      }
+    }
+    public string Donor { get { return "Dr. Henrique da Mota"; } }
+    public int Year { get { return 2011; } }
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 8900)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 8903)
@@ -120,4 +120,6 @@
     <Compile Include="Classification\ResourceClassificationDataDescriptor.cs" />
     <Compile Include="Classification\ResourceClassificationInstanceProvider.cs" />
+    <Compile Include="Classification\UCI\Vertebral_3C.cs" />
+    <Compile Include="Classification\UCI\Parkinson.cs" />
     <Compile Include="Classification\UCI\Iris.cs" />
     <Compile Include="Classification\UCI\IUCIDataDescriptor.cs" />