Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.Designer.cs	(revision 8924)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.Designer.cs	(revision 8925)
@@ -49,11 +49,9 @@
       this.label2 = new System.Windows.Forms.Label();
       this.dataRowComboBox = new System.Windows.Forms.ComboBox();
-      this.label3 = new System.Windows.Forms.Label();
-      this.groupByComboBox = new System.Windows.Forms.ComboBox();
       this.SuspendLayout();
       // 
       // dataTableComboBox
       // 
-      this.dataTableComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.dataTableComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.dataTableComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
@@ -76,6 +74,6 @@
       // viewHost
       // 
-      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.viewHost.Caption = "View";
@@ -101,5 +99,5 @@
       // dataRowComboBox
       // 
-      this.dataRowComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.dataRowComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.dataRowComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
@@ -111,34 +109,8 @@
       this.dataRowComboBox.SelectedIndexChanged += new System.EventHandler(this.dataRowComboBox_SelectedIndexChanged);
       // 
-      // label3
-      // 
-      this.label3.AutoSize = true;
-      this.label3.Location = new System.Drawing.Point(3, 61);
-      this.label3.Name = "label3";
-      this.label3.Size = new System.Drawing.Size(53, 13);
-      this.label3.TabIndex = 5;
-      this.label3.Text = "Grouping:";
-      // 
-      // groupByComboBox
-      // 
-      this.groupByComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.groupByComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.groupByComboBox.FormattingEnabled = true;
-      this.groupByComboBox.Items.AddRange(new object[] {
-            "None",
-            "Same runs",
-            "All"});
-      this.groupByComboBox.Location = new System.Drawing.Point(69, 58);
-      this.groupByComboBox.Name = "groupByComboBox";
-      this.groupByComboBox.Size = new System.Drawing.Size(455, 21);
-      this.groupByComboBox.TabIndex = 6;
-      this.groupByComboBox.SelectedIndexChanged += new System.EventHandler(this.groupByComboBox_SelectedIndexChanged);
-      // 
       // RunCollectionDataTableView
       // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.groupByComboBox);
-      this.Controls.Add(this.label3);
       this.Controls.Add(this.dataRowComboBox);
       this.Controls.Add(this.label2);
@@ -160,6 +132,4 @@
     private System.Windows.Forms.Label label2;
     private System.Windows.Forms.ComboBox dataRowComboBox;
-    private System.Windows.Forms.Label label3;
-    private System.Windows.Forms.ComboBox groupByComboBox;
   }
 }
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.cs	(revision 8924)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.cs	(revision 8925)
@@ -220,5 +220,4 @@
       dataRowComboBox.Items.Add(AllDataRows);
       if (dataRowComboBox.Items.Count > 0) dataRowComboBox.SelectedItem = dataRowComboBox.Items[0];
-      groupByComboBox.SelectedItem = groupByComboBox.Items[0];
     }
 
@@ -227,46 +226,5 @@
     }
     private void dataRowComboBox_SelectedIndexChanged(object sender, System.EventArgs e) {
-      //      RebuildCombinedDataTable();
-      groupByComboBox_SelectedIndexChanged(sender, e);
-    }
-    private void groupByComboBox_SelectedIndexChanged(object sender, System.EventArgs e) {
-      var resultName = (string)dataTableComboBox.SelectedItem;
-      var groupByCriteriaName = (string)groupByComboBox.SelectedItem;
-      switch (groupByCriteriaName) {
-        case ("None"): {
-            combinedDataTable.Rows.Clear();
-            RebuildCombinedDataTable();
-            break;
-          }
-        case ("Same runs"): {
-            var rowName = (string)dataRowComboBox.SelectedItem;
-            var runGroups = Content.GroupBy(r => r.Algorithm);
-            combinedDataTable.Rows.Clear();
-            foreach (var g in runGroups) {
-              var dataTable = g.Select(r => r.Results[resultName] as DataTable);
-              var rows = dataTable.SelectMany(d => d.Rows.Where(row => row.Name == rowName)).ToList();
-              var avgRow = new DataRow { VisualProperties = { StartIndexZero = true }, Name = resultName + "." + rowName };
-              var min = rows.Min(r => r.Values.Count);
-              for (int i = 0; i != min; ++i) {
-                avgRow.Values.Add(rows.Average(r => r.Values[i]));
-              }
-              combinedDataTable.Rows.Add(avgRow);
-            }
-            break;
-          }
-        case ("All"): {
-            var rowName = (string)dataRowComboBox.SelectedItem;
-            RebuildCombinedDataTable();
-            var rows = combinedDataTable.Rows;
-            var avgRow = new DataRow { VisualProperties = { StartIndexZero = true }, Name = resultName + "." + rowName };
-            var min = rows.Min(r => r.Values.Count);
-            for (int i = 0; i != min; ++i) {
-              avgRow.Values.Add(rows.Average(r => r.Values[i]));
-            }
-            combinedDataTable.Rows.Clear();
-            combinedDataTable.Rows.Add(avgRow);
-            break;
-          }
-      }
+      RebuildCombinedDataTable();
     }
   }