Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.Designer.cs	(revision 8941)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.Designer.cs	(revision 8942)
@@ -21,5 +21,5 @@
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
-  partial class SymbolicExpressionTreeChart {
+  public partial class SymbolicExpressionTreeChart {
     /// <summary> 
     /// Required designer variable.
@@ -70,5 +70,5 @@
       // 
       this.saveFileDialog.Filter = "Bitmap (*.bmp)|*.bmp|EMF (*.emf)|*.emf";
-      this.saveFileDialog.FilterIndex = 1;      
+      this.saveFileDialog.FilterIndex = 1;
       // SymbolicExpressionTreeChart
       // 
@@ -89,8 +89,8 @@
     #endregion
 
-    private System.Windows.Forms.ToolTip toolTip;
-    private System.Windows.Forms.ContextMenuStrip contextMenuStrip;
-    private System.Windows.Forms.ToolStripMenuItem saveImageToolStripMenuItem;
-    private System.Windows.Forms.SaveFileDialog saveFileDialog;
+    protected System.Windows.Forms.ToolTip toolTip;
+    protected System.Windows.Forms.ContextMenuStrip contextMenuStrip;
+    protected System.Windows.Forms.ToolStripMenuItem saveImageToolStripMenuItem;
+    protected System.Windows.Forms.SaveFileDialog saveFileDialog;
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 8941)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 8942)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
-  public sealed partial class SymbolicExpressionTreeChart : UserControl {
+  public partial class SymbolicExpressionTreeChart : UserControl {
     private Image image;
     private StringFormat stringFormat;
@@ -36,7 +36,5 @@
       InitializeComponent();
       this.image = new Bitmap(Width, Height);
-      this.stringFormat = new StringFormat();
-      this.stringFormat.Alignment = StringAlignment.Center;
-      this.stringFormat.LineAlignment = StringAlignment.Center;
+      this.stringFormat = new StringFormat { Alignment = StringAlignment.Center, LineAlignment = StringAlignment.Center };
       this.spacing = 5;
       this.lineColor = Color.Black;
@@ -157,5 +155,5 @@
     #region events
     public event MouseEventHandler SymbolicExpressionTreeNodeClicked;
-    private void OnSymbolicExpressionTreeNodeClicked(object sender, MouseEventArgs e) {
+    protected virtual void OnSymbolicExpressionTreeNodeClicked(object sender, MouseEventArgs e) {
       var clicked = SymbolicExpressionTreeNodeClicked;
       if (clicked != null)
@@ -165,10 +163,11 @@
     private void SymbolicExpressionTreeChart_MouseClick(object sender, MouseEventArgs e) {
       VisualSymbolicExpressionTreeNode visualTreeNode = FindVisualSymbolicExpressionTreeNodeAt(e.X, e.Y);
-      if (visualTreeNode != null)
+      if (visualTreeNode != null) {
         OnSymbolicExpressionTreeNodeClicked(visualTreeNode, e);
+      }
     }
 
     public event MouseEventHandler SymbolicExpressionTreeNodeDoubleClicked;
-    private void OnSymbolicExpressionTreeNodeDoubleClicked(object sender, MouseEventArgs e) {
+    protected virtual void OnSymbolicExpressionTreeNodeDoubleClicked(object sender, MouseEventArgs e) {
       var doubleClicked = SymbolicExpressionTreeNodeDoubleClicked;
       if (doubleClicked != null)
@@ -183,5 +182,5 @@
 
     public event ItemDragEventHandler SymbolicExpressionTreeNodeDrag;
-    private void OnSymbolicExpressionTreeNodeDragDrag(object sender, ItemDragEventArgs e) {
+    protected virtual void OnSymbolicExpressionTreeNodeDragDrag(object sender, ItemDragEventArgs e) {
       var dragged = SymbolicExpressionTreeNodeDrag;
       if (dragged != null)
@@ -234,5 +233,5 @@
     /// 
     /// </summary>
-    /// <param name="functionTree"> functiontree to draw</param>
+    /// <param name="functionTree"> function tree to draw</param>
     /// <param name="graphics">graphics object to draw on</param>
     /// <param name="x">x coordinate of drawing area</param>